
$regfile = "m8def.dat"
$crystal = 16000000
$baud = 115200
'------------------------------------------
Const Falloff = 1
Const Czulosc = 30                                           '  10  40
Const Timer1_l = _xtal / 3000
Const Poziom_a = 8 -(czulosc * 0.4)
'------------------------------------------

'    
Dim Rs232_outframe(6) As Byte
Dim Startvalue As Byte , Temp As Byte
Dim Channel As Byte
Dim Div As Iram Integer At 16
Dim K As Byte
Dim I As Byte
Dim Tmp_s As Integer
Dim Tmp_c As Integer
Dim Beta As Iram Byte
Dim Suma As Word
Dim Sam As Byte
Dim Sampling As Bit
Dim Rex_t As Integer , Imx_t As Integer
Dim Dane(32) As Integer
Dim Sample_l(32) As Integer                                 ' 32     64 
Dim Okno(32) As Byte                                        '     32
Dim Rex(16) As Integer                                      ' 16   rex         32 
Dim Sinus(40) As Integer                                    '   40     80 
Dim Wynik(16) As Byte , Wynik_o(16) As Byte                 '   2   16 
Dim Sing As Single
Dim Poziom As Integer
Dim Falloff_count(16) As Byte                               '    16 


'Waitms 10

'----------------------    -------------------------------------------
Reset Watchdog
Config Watchdog = 256
Stop Watchdog
'-------------------------------------------------------------------------------

'----------------------   -------------------------------------------
Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc
'-------------------------------------------------------------------------------

'----------------------   ---------------------------------------
Config Timer1 = Timer , Prescale = 1
On Compare1b Samplel                                        '  Compare1b  
Compare1b = Timer1_l
Enable Timer1
Start Timer1
'-------------------------------------------------------------------------------

'----------------------   ---------------------------------------
Enable Interrupts
Disable Int0
Disable Int1

'------------------    40  ---------------------------
For K = 0 To 31
Sinus(k + 1) = Lookup(k , Tab_sin)
Okno(k + 1) = Lookup(k , Okno_hanning)
Next K

Sinus(33) = Lookup(0 , Tab_sin)
Sinus(34) = Lookup(1 , Tab_sin)
Sinus(35) = Lookup(2 , Tab_sin)
Sinus(36) = Lookup(3 , Tab_sin)
Sinus(37) = Lookup(4 , Tab_sin)
Sinus(38) = Lookup(5 , Tab_sin)
Sinus(39) = Lookup(6 , Tab_sin)
Sinus(40) = Lookup(7 , Tab_sin)
'-------------------------------------------------------------------------------

Start Watchdog

'-------------------------------------------------------------------------------

'---------------------------   -------------------------------------

Main:
Do
Reset Watchdog

Main_1:
If Sampling = 1 Then Goto Main_1                            '  Sampling = 1     32 

Gosub Sample_l                                              '   32                                                '
Gosub Copy_low                                              '    
Gosub Dft                                                   '   
Gosub Przelicz_low                                          '    
Gosub Save

Loop
'-------------------------------------------------------------------------------

Copy_low:
   Poziom = 0

   For K = 1 To 32
      Div = Sample_l(k)
      asr r17:ror r16:asr r17:ror r16
      Sample_l(k) = Div
      Poziom = Poziom + Sample_l(k)
   Next K

   Div = Poziom
   asr r17:ror r16:asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
   asr r17:ror r16
   Poziom = Div

   For K = 1 To 32
      Dane(k) = Sample_l(k) - Poziom
      Dane(k) = Dane(k) * Okno(k)
      Div = Dane(k)
      asr r17:ror r16:asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
      asr r17:ror r16:asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
      Dane(k) = Div
      If Dane(k) > 127 Then Dane(k) = 127
      If Dane(k) < -127 Then Dane(k) = -127
   Next K
Return


Dft:
'  
'       
For K = 1 To 16                                             ' 15   32 
 Rex_t = 0
 Imx_t = 0

   For I = 0 To 31
      Beta = I * K
      Beta = Beta And 31
      Tmp_s = Sinus(beta + 1) * Dane(i + 1)
      Tmp_c = Sinus(beta + 8) * Dane(i + 1)

      Div = Tmp_s
      asr r17:ror r16:asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
      asr r17:ror r16:asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
      Tmp_s = Div

      Div = Tmp_c
      asr r17:ror r16:asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
      asr r17:ror r16:asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
      Tmp_c = Div

     Rex_t = Rex_t + Tmp_c
     Imx_t = Imx_t - Tmp_s

   Next I

   Div = Rex_t
   asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
   Rex_t = Div

   Div = Imx_t
   asr r17:ror r16:asr r17:ror r16:asr r17:ror r16
   Imx_t = Div

   Tmp_c = Rex_t * Rex_t
   Tmp_s = Imx_t * Imx_t

   Tmp_c = Tmp_c + Tmp_s
   Rex(k + 1) = Sqr(tmp_c)                                  '   REX(16)      
Next K
Return


Sample_l:
' 32    2 
'Config Adc = Single , Prescaler = Auto , Reference = Avcc
'Start Adc

Timer1 = 0
Enable Compare1b
Sam = 0                                                     '
Sampling = 1                                                '    = 1         32 
Return


Samplel:
Timer1 = 0
Incr Sam
Sample_l(sam) = Getadc(0)                                   '
If Sam = 32 Then
   Disable Compare1b
   Sampling = 0
End If
Return


'---------  (1-8 )--------------

' Wynik(1-5)   

Przelicz_low:
Suma = Rex(3)
Wynik(1) = Suma

Suma = Rex(4)
Wynik(2) = Suma

Suma = Rex(5)
Wynik(3) = Suma

Suma = Rex(6)
If Rex(7) > Suma Then Suma = Rex(7)
Wynik(4) = Suma

Suma = Rex(8)
If Rex(9) > Suma Then Suma = Rex(9)
Wynik(5) = Suma

Suma = Rex(10)
If Rex(11) > Suma Then Suma = Rex(11)
Wynik(6) = Suma

Suma = Rex(12)
If Rex(13) > Suma Then Suma = Rex(13)
Wynik(7) = Suma

Suma = Rex(13)
If Rex(14) > Suma Then Suma = Rex(14)
Wynik(8) = Suma
Return



Save:

'  wynik(1-8)      0-16
'-------------  16 ---------------

For K = 1 To 8
Sing = Wynik(k) * 0.1

If K = 1 Then Sing = Sing * 0.5                             ' 1
If K = 2 Then Sing = Sing * 0.5                             ' 2


Sing = Log10(sing)                                          '   

Sing = Czulosc * Sing
Tmp_c = Sing + Poziom_a

'-----------------------------

If Tmp_c < 0 Then Tmp_c = 0                                 '       0  16
If Tmp_c > 16 Then Tmp_c = 16

Wynik(k) = Tmp_c

If Wynik(k) > Wynik_o(k) Then
   Wynik_o(k) = Wynik(k)

Else
   If Falloff_count(k) = Falloff Then
      If Wynik_o(k) > 0 Then Decr Wynik_o(k)
      Falloff_count(k) = 0
   End If
   Incr Falloff_count(k)
End If

Next K


For K = 1 To 8
Channel = K                                                 ' 
'----------------------------------------------------------------------------
Startvalue = Wynik_o(k)                                     '       !!!!!!!!!!!!!!!!!!
Startvalue = Startvalue * 15                                '      240 
'-----------------------------------------------------------------------------
Gosub Sendrs232
Next K
Return



'----------------------------    -----------------------------
' -----------------   PC DIMMER------------------------------------------

Sendrs232:


'RS232 
'*************ADRESSE****************
Temp = Channel + 127                                        '   -  
   Rs232_outframe(1) = Temp                                 '  1 = "",        [0 .127]
'**************STEPS*****************
   Rs232_outframe(2) = 0                                    '   -     
'*************FADE_1****************
   Rs232_outframe(3) = 0                                    ' 
'*************FADE_2****************
   Rs232_outframe(4) = 0                                    ' 
'*************FADE_3****************
   Rs232_outframe(5) = 0                                    ' 
'*************ENDWERT***************
Temp = 255 - Startvalue
Temp = Temp / 2
Temp = Temp And 127
   Rs232_outframe(6) = Temp                                 '      [0..127]

Printbin Rs232_outframe(1) ; 6

Return


'   32 - 16    
' zaoony format: MSB - cz cakowita, LSB - cz uamkowa
' : 0.19635 
' tabela I wiartki sin(x), 8 pozycji (co 11,25 stopnia od 0 do 78.75)
Tab_sin:
Data 0% , 50% , 98% , 142% , 181% , 213% , 237% , 251%
' tabela II wiartki sin(x), (co 11,25 stopnia od 90 do 178.75)
Data 255% , 251% , 237% , 213% , 181% , 142% , 98% , 50%
' tabela III i IV wiartki sin(x), (co 11,25 stopnia od 180 do 258.75 i 270 - 348.75)
' zanegowane 2 poprzednie tabele
Data 0% , -50% , -98% , -142% , -181% , -213% , -237% , -251%
Data -255% , -251% , -237% , -213% , -181% , -142% , -98% , -50%

Okno_hanning:
Data 0 , 3 , 10 , 23 , 40 , 60 , 84 , 109 , 134 , 160 , 184 , 206 , 225 , 240 , 250 , 255 , 255 , 250 , 240 , 225 , 206 , 184 , 160 , 134 , 109 , 84 , 60 , 40 , 23 , 10 , 3 , 0
